#ifndef ELEMENTBEAM_SEEN
#define ELEMENTBEAM_SEEN

#include <iostream>
#include <string>

#include "abstractElement.h"

using namespace std;

class elementBeam : public abstractElement
{
    
    double x_, xp_, y_, yp_;
    double dl_, del_;
    double p0_;
    
    double xDef_, xpDef_, yDef_, ypDef_;
    double dlDef_, delDef_;
    double p0Def_;
    
    void setDefaultValues();
    void setDefaults();
    
 public :
    
    elementBeam();
    ~elementBeam();
    
    
    virtual void setParametersString(string* param);
    virtual string* getParametersString() const;
    virtual vector< pair<string, vector<string> > > parametersToSoftware () const;
    //    virtual  string parmelaOutputFlow() const;
    //    virtual string transportOutputFlow() const;
    
    virtual string FileOutputFlow() const;    
    virtual void FileInput(ifstream& ifs);
    virtual void InputRep(UAPNode* root);

    /** return a string with all parameters and value */
    string print();
};
#endif
