#ifndef GWT_CELL_SEEN
#define GWT_CELL_SEEN

#include "GWt_abstractElement.h"
#include "abstractElement.h"

#include <iostream>
#include <string>
#include <sstream>

using namespace Wt;
using namespace std;

class GWt_cell : public GWt_abstractElement
{
  WLineEdit* lenghtElemEdit_; // cm
  WLineEdit* apertureEdit_; // cm
  WLineEdit* initialPhaseEdit_; // degres
  WLineEdit* phaseStepMaxEdit_;   // degres
  WLineEdit* acceleratingFieldEdit_; // MV/m
  WLineEdit* acceleratingShapeFileEdit_; // string
  WLineEdit* focusingMagFileEdit_; // string
  WLineEdit* offsetMagEdit_; // cm
  WLineEdit* scaleFactorEdit_;
      
 public :
    
  GWt_cell() {;}
  GWt_cell(GWt_elementLigneFaisceau* );
  ~GWt_cell() {;}
 
  virtual void dialogDone(WDialog::DialogCode code);
  WImage* getImage();
    
  inline string getMimeType() {return "htdocs/cell.jpg"; }
  inline string getSmallImageURL() {return "htdocs/cell.jpg"; }
  inline string getBigImageURL() {return "htdocs/cell.jpg"; }
  inline string getName() {return "cell"; }
  
 private :

  void initilializeDialog();
  
};
#endif
